#!/usr/bin/env python
# -*- encoding: utf-8 -*-

from django.http import HttpResponseForbidden
from django.contrib.auth import logout
from django.template.loader import get_template
from django.template import Context
from django.conf import settings

from auf_references_modeles import Utilisateur, GroupesPersonne

import sys, traceback

def has_group(group = ""):
    def _dec(view_func):
        def _view(request, *args, **kwargs):
            allowed = False
            print getattr(settings, 'ROA_MODELS', False)
            if request.user.is_authenticated():
                try:
                    p = Utilisateur.objects.get(courriel = request.user.email)
                    #g = Groupe.objects.get(nom = group)
                    for g in GroupesPersonne.objects.filter(personne__pk = p.pk):
                        if g.groupe.nom == group:
                            allowed = True
                            break
                except:
                    print "Exception in user code:"
                    print '-'*60
                    traceback.print_exc(file=sys.stdout)
                    print '-'*60
            else:
                allowed = True
    
            if allowed:
                r = view_func(request, *args, **kwargs)
            else:
                logout(request)
                t = get_template('references_403.html')
                html = t.render(Context({}))
                r = HttpResponseForbidden(html)

            return r

        _view.__name__ = view_func.__name__
        _view.__dict__ = view_func.__dict__
        _view.__doc__ = view_func.__doc__

        return _view
    return _dec
